using System;
using System.Text;
using System.Security.Cryptography;
using System.IO;

namespace WingTokenModule.Common
{
    /// <summary>
    /// AES
    /// </summary>
    public static class AES
    {
        /// <summary>
        /// 默认密钥-密钥的长度必须是32
        /// </summary>
        private static string _publicKey = "FFF23736B0A749A987B1C8BFC68601AD";

        /// <summary>
        /// AES加密
        /// </summary>
        /// <param name="obj"></param>
        /// <typeparam name="T"></typeparam>
        /// <returns></returns>
        public static string Encrypt<T>(T obj) where T : new()
        {
            return Encrypt(Newtonsoft.Json.JsonConvert.SerializeObject(obj));
        }

        /// <summary>
        /// AES加密
        /// </summary>
        /// <param name="input">需要加密的字符串</param>
        public static string Encrypt(string input)
        {
            var encryptKey = Encoding.UTF8.GetBytes(_publicKey);
            using (var aesAlg = Aes.Create())
            {
                using (var encryptor = aesAlg.CreateEncryptor(encryptKey, aesAlg.IV))
                {
                    using (var msEncrypt = new MemoryStream())
                    {
                        using (var csEncrypt = new CryptoStream(msEncrypt, encryptor,
                            CryptoStreamMode.Write))

                        using (var swEncrypt = new StreamWriter(csEncrypt))
                        {
                            swEncrypt.Write(input);
                        }

                        var iv = aesAlg.IV;
                        var decryptedContent = msEncrypt.ToArray();
                        var result = new byte[iv.Length + decryptedContent.Length];
                        Buffer.BlockCopy(iv, 0, result, 0, iv.Length);
                        Buffer.BlockCopy(decryptedContent, 0, result,
                            iv.Length, decryptedContent.Length);
                        return Convert.ToHexString(result);
                    }
                }
            }
        }

        /// <summary>
        /// AES解密
        /// </summary>
        /// <param name="input"></param>
        /// <typeparam name="T"></typeparam>
        /// <returns></returns>
        public static T Decrypt<T>(string input)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<T>(Decrypt(input));
        }

        /// <summary>
        /// AES解密
        /// </summary>
        /// <param name="input">需要解密的字符串</param>
        public static string Decrypt(string input)
        {
            var fullCipher = Convert.FromHexString(input);
            byte[] iv = new byte[16];
            var cipher = new byte[fullCipher.Length - iv.Length];
            Buffer.BlockCopy(fullCipher, 0, iv, 0, iv.Length);
            Buffer.BlockCopy(fullCipher, iv.Length, cipher, 0, fullCipher.Length - iv.Length);
            var key = Encoding.UTF8.GetBytes(_publicKey);
            using (var aesAlg = Aes.Create())
            {
                using (var decryptor = aesAlg.CreateDecryptor(key, iv))
                {
                    string result;
                    using (var msDecrypt = new MemoryStream(cipher))
                    {
                        using (var csDecrypt = new CryptoStream(msDecrypt, decryptor, CryptoStreamMode.Read))
                        {
                            using (var srDecrypt = new StreamReader(csDecrypt))
                            {
                                result = srDecrypt.ReadToEnd();
                            }
                        }
                    }

                    return result;
                }
            }
        }
    }
}